'+--------------------------------------------------------------------------+
'|                                TRON3D                                    |
'|                                                                          |
'|                           GDImage animation                              |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|            8 Domaine de Rochagnon. 38800 Champagnier  FRANCE             |
'|                       http://www.zapsolution.com                         |
'|                    E-mail: pterrier@zapsolution.com                      |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 05-30-2011                         |
'|                        Last revised : 06-01-2011                         |
'+--------------------------------------------------------------------------+

#COMPILE EXE "Tron3D.exe"

#INCLUDE "WIN32API.inc"
#INCLUDE "GDImage.inc"
#INCLUDE "WinLIFT.inc"
'#RESOURCE "Tron.pbr"
#RESOURCE ICON, 2, "Tron.ico"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

%NM_FIRST           = 0
%NM_AUDIOCOMPLETION = %NM_FIRST - 80
%NM_MOVIEPLAYING    = %NM_FIRST - 81

%CLIENT_WIDTH       = 750
%CLIENT_HEIGHT      = 474
%CTRL_WIDTH         = 392
%CTRL_HEIGHT        = 392

%IDC_GDImageCTRL    = -1
%IDC_MOTORCYCLE     = -2
%IDC_STATIC         = -3
%IDC_TIMER          = 1


%ID_FIRST           = 1
%ID_Layer1          = %ID_FIRST
%ID_Layer2          = %ID_FIRST + 1
%ID_Layer3          = %ID_FIRST + 2
%ID_Layer4          = %ID_FIRST + 3
%ID_Layer5          = %ID_FIRST + 4
%ID_Layer6          = %ID_FIRST + 5
%ID_LAST            = %ID_Layer6

GLOBAL gnSkinActive, gnSequence AS LONG, gh_Main AS DWORD
GLOBAL WM_ZWPNOTIFICATION AS LONG

FUNCTION WinMain (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL rc          AS RECT
    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL IsInitialized, x, y AS LONG, dwStyleEx, dwStyle, hMutex AS DWORD
'
    zClass = "ZTRON"

    hMutex = CreateMutex(BYVAL 0&, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             gh_Main = FindWindow(zClass, ""): IF gh_Main THEN EXIT DO
             WHILE PeekMessage(Msg, 0, 0, 0, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(gh_Main) THEN CALL ShowWindow(gh_Main, %SW_RESTORE)
          CALL SetForeGroundWindow(gh_Main)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(hInstance, zClass, wc)
    IF IsInitialized&   = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0 '// %EXTEND_EXTRA * 4
       wc.hInstance     = hInstance
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL ' GetStockObject(%BLACK_BRUSH)
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     ' Window Extended Style
       dwStyleEx = %WS_EX_APPWINDOW OR %WS_EX_WINDOWEDGE
     ' Windows Style
       dwStyle = %WS_OVERLAPPEDWINDOW OR %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN
'
       CALL SetRect(rc, 0, 0, %CLIENT_WIDTH, %CLIENT_HEIGHT )
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwStyleEx) ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) * 0.5, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) * 0.5, 0)
'
     ' Create The Window
       MyTitle$ = "TRON"
       gh_Main = CreateWindowEx(dwStyleEx, _          ' Extended Style For The Window
                             zClass, _                ' Class Name
                             (MyTitle$), _            ' Window Title
                             dwStyle, _               ' Defined Window Style
                             x, y, _                  ' Window Position
                             rc.nRight - rc.nLeft, _  ' Calculate Window Width
                             rc.nBottom - rc.nTop, _  ' Calculate Window Height
                             %NULL, _                 ' No Parent Window
                             %NULL, _                 ' No Menu
                             hInstance,    _          ' Instance
                             BYVAL %NULL)             ' Dont Pass Anything To WM_CREATE
'
       IF gh_Main THEN
          LOCAL sResPath AS STRING, nID, nW, nH AS LONG, hBitmap, hCtrl AS DWORD
          sResPath = EXE.Path$ + "Resource\"


          WM_ZWPNOTIFICATION = RegisterWindowMessage("ZWPnotification")
          ZWP_RUN()

          dwStyle = %WS_CHILD OR %WS_VISIBLE
          x = (%CLIENT_WIDTH - %CTRL_WIDTH) * 0.5
          y = (%CLIENT_HEIGHT - %CTRL_HEIGHT) * 0.5 + 12
          hCtrl = CreateWindowEx(0, $GDImageClassName, "", dwStyle, x, y, %CTRL_WIDTH, %CTRL_HEIGHT, gh_Main, %IDC_GDImageCTRL, hInstance, BYVAL 0)
          CALL ZI_SetAnchorMode(hCtrl, %ANCHOR_CENTER)
          '// Gradiant color to paint the background
          CALL ZI_SetProperty(hCtrl, %ZI_GradientTop, 0)
          CALL ZI_SetProperty(hCtrl, %ZI_GradientBottom, 0)

          FOR nID = %ID_FIRST TO %ID_LAST
              hBitmap = ZI_CreateBitmapFromFile(sResPath + "Layer" + LTRIM$(STR$(nID)) + ".png", nW, nH)
              ZD_DrawBitmapToCtrl(hCtrl, 0, 0, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)
              ZD_SetObjectLocked(nID, %TRUE)
          NEXT


          IF skInitEngine("Tron.sks", "") THEN
             skSkinWindow(gh_Main, "Dock|Undock|Minimize|Maximize|Restore|Close")
             gnSkinActive = -1
             hCtrl = skPushButtonImage(gh_Main, sResPath + "MotorCycle.png", " ", %CLIENT_WIDTH + 4, 0, %CLIENT_WIDTH + 4, 24, %IDC_MOTORCYCLE, %BS_LEFT)' OR %BS_VCENTER)
             EnableWindow(hCtrl, %FALSE)
          END IF

'         // To perform audio file drag and drop
          CALL DragAcceptFiles(gh_Main, %TRUE)

'         // Run ZWP with the default plugin
          ZWP_Show(EXE.Path$ + "Resource\TronGRID.ogg")


        ' Show the main window
          CALL ShowWindow(gh_Main, %SW_SHOW)
          CALL SetForegroundWindow(gh_Main)                  ' Slightly Higher Priority

          gnSequence = 1


          CALL SetTimer(gh_Main, %IDC_TIMER, 0, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)
              'IF IsDialogMessage(gh_Main, Msg) = %FALSE THEN
                 CALL TranslateMessage(msg)                ' Translate The Message
                 CALL DispatchMessage(msg)                 ' Dispatch The Message
              'END IF
          WEND
          CALL KillTimer(gh_Main, %IDC_TIMER)

          FUNCTION = msg.wParam
       END IF

    END IF

    IF hMutex THEN CALL CloseHandle(hMutex)

END FUNCTION

SUB RenderAnimation(BYVAL hWnd AS DWORD)

    LOCAL nX, nY, nW, nH AS LONG, hCtrl AS DWORD, rc AS RECT, p AS POINTAPI
    STATIC nFlip, nTempo, AnimDone AS LONG
    

    IF nTempo < GetTickcount() THEN

       ZD_GetObjectXY(%ID_Layer2, nX, nY)
       IF nFlip = 0 THEN
          IF nX > -68 THEN
             nX -= 2
          ELSE
             nFlip = -1
          END IF
       ELSE
          IF nX < 0 THEN
             nX += 2
          ELSE
             nFlip = 0
          END IF
       END IF 
    
       ZD_SetObjectRed(%ID_Layer1, 187 + nX, %FALSE)
       ZD_SetObjectBlue(%ID_Layer1, -nX * 2, %FALSE)
    
    
       ZD_SetObjectXY(%ID_Layer2,  nX, nY, %FALSE)  
       ZD_SetObjectXY(%ID_Layer3, -nX, nY, %FALSE)  
    
       ZD_SetObjectAngle(%ID_Layer5, -nX, %FALSE)
    
       IF gnSequence = 1 THEN 
          ZD_SetObjectAlpha(%ID_Layer6, 255 + nX, %FALSE)
          ZD_SetObjectScale(%ID_Layer6, 1 + (-nX * 0.005))
       ELSE
          ZD_SetObjectScale(%ID_Layer6, 3 - (1 + (-nX * 0.005) * 4))
       END IF
    
       ZI_UpdateWindow(GetDlgItem(hWnd, %IDC_GDImageCTRL), 0)

       nTempo = GetTickCount() + 40 '// 25 FPS = 40 ticks
    END IF

    IF AnimDone = 0 THEN
       hCtrl = GetDlgItem(hWnd, %IDC_MOTORCYCLE)
       CALL GetWindowRect(hCtrl, rc): p.X = rc.nLeft: p.Y = rc.nTop: ScreenToClient(GetParent(hCtrl), p)
       IF p.X > -3 THEN
          p.X -= 2
          nH = rc.nBottom - rc.nTop: GetClientRect(GetParent(hCtrl), rc): nW = rc.nRight - rc.nLeft
          MoveWindow(hCtrl, p.X, p.Y, nW - p.X, nH, 1)
          ZI_SetAnchorMode(hCtrl, %ANCHOR_WIDTH) 
       ELSE
          AnimDone = -1
       END IF
    END IF

END SUB

FUNCTION WndProc(BYVAL hWnd AS DWORD, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT

    SELECT CASE LONG Msg

'   CASE %WM_CREATE
'
    CASE WM_ZWPNOTIFICATION
         IF wParam = %NM_AUDIOCOMPLETION THEN
            INCR gnSequence
            IF gnSequence > 2 THEN gnSequence = 1
            'ZWP_Hide()
'            ZD_DeleteObject(%ID_Layer6)
            IF gnSequence = 1 THEN
               ZWP_UsePlugin(EXE.Path$ + "BBplugin\Hud_Ring.dll")
               ZWP_Show(EXE.Path$ + "Resource\TronGRID.ogg")
               ZD_SetObjectBitmapFromFile(EXE.Path$ + "Resource\Layer6.png", %ID_Layer6, %TRUE)
            ELSE
               ZWP_UsePlugin(EXE.Path$ + "BBplugin\Hud_Beam.dll")
               ZWP_Show(EXE.Path$ + "Resource\TronSOF.ogg")
               ZD_SetObjectScale(%ID_Layer6, 1)
               ZD_SetObjectAlpha(%ID_Layer6, 255, %FALSE)
               ZD_SetObjectBitmapFromFile(EXE.Path$ + "Resource\Layer6_bis.png", %ID_Layer6, %TRUE)
            END IF
         END IF

    CASE %WM_SIZE, %WM_MOVE, %WM_WINDOWPOSCHANGED, %WM_IME_NOTIFY
         IF ZWP_Handle() THEN
            ZWP_SizeMove()
         END IF

'   CASE %WM_COMMAND
'        SELECT CASE LONG LOWRD(wParam)
'        END SELECT

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam

         IF gnSkinActive THEN
            @pMM.ptMinTrackSize.x = MinTrackSizeX(0)
            @pMM.ptMinTrackSize.y = MinTrackSizeY(0)
         ELSE
            CALL SetRect(rc, 0, 0, %CLIENT_WIDTH, %CLIENT_HEIGHT)
            CALL AdjustWindowRectEx(rc, GetWindowLong(hWnd, %GWL_STYLE), %FALSE, GetWindowLong(hWnd, %GWL_EXSTYLE)) ' Adjust Window To True Requested Size
            @pMM.ptMinTrackSize.x = rc.nRight - rc.nLeft
            @pMM.ptMinTrackSize.y = rc.nBottom - rc.nTop
         END IF

         LOCAL hMonitor AS LONG, tmi AS MONITORINFO
         hMonitor = MonitorFromWindow(hWnd, %MONITOR_DEFAULTTONEAREST)
         tmi.cbSize = SIZEOF(tmi)
         IF GetMonitorInfo(hMonitor, tmi) THEN
            @pMM.ptMaxSize.x = tmi.rcWork.nRight - tmi.rcWork.nLeft
            @pMM.ptMaxSize.y = tmi.rcWork.nBottom - tmi.rcWork.nTop
         END IF

    CASE %WM_DROPFILES '// Drag & drop
         LOCAL nRet AS LONG 
         LOCAL szFileName AS ASCIIZ * %MAX_PATH
         nRet = DragQueryFile(wParam, -1, "", 0)
         IF nRet > 0 THEN
            nRet = DragQueryFile(wParam, 0, szFileName, %MAX_PATH)
            IF nRet > 0 THEN ZWP_Show(szFileName)
         END IF
         DragFinish(wParam)

    CASE %WM_ERASEBKGND
         CALL GetClientRect(hWnd, rc)
         CALL ZI_GradientPaintDC(wParam, 0, 0, rc.nRight, rc.nBottom, RGB(0,0,0), RGB(0,0,0))
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_TIMER
         RenderAnimation(hWnd)
         FUNCTION = 0: EXIT FUNCTION

'   CASE %WM_PAINT
'        FUNCTION = 0: EXIT FUNCTION
'
'   CASE %WM_CLOSE

    CASE %WM_DESTROY
         ZWP_Destroy()
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB SetStaticValue(BYVAL sUseString AS STRING, BYVAL nValue AS LONG)
    LOCAL nIndex, nStaticHandle AS LONG
    sUseString += "|"
    nStaticHandle = GetDlgItem(gh_Main, %IDC_STATIC)
    IF nStaticHandle = 0 THEN
      nStaticHandle = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_HASSTRINGS, 0, 0, 0, 0, gh_Main, %IDC_STATIC, zInstance(), BYVAL %NULL)
    END IF
    IF nStaticHandle THEN
       nIndex = SendMessage(nStaticHandle, 399, -1, BYVAL STRPTR(sUseString))
       IF nIndex > -1 THEN '// We found same static
          CALL SendMessage(nStaticHandle, 410, nIndex, nValue)
       ELSE '// Add it to our static list
          CALL SendMessage(nStaticHandle, 410, SendMessage(nStaticHandle, 384, 0, BYVAL STRPTR(sUseString)), nValue)
       END IF
    END IF
END SUB

FUNCTION GetStaticValue(BYVAL sUseString AS STRING) AS LONG
    LOCAL nIndex, nValue, nStaticHandle AS LONG
    sUseString += "|"
    nValue = 0
    nStaticHandle = GetDlgItem(gh_Main, %IDC_STATIC)
    IF nStaticHandle THEN
       nIndex = SendMessage(nStaticHandle, 399, -1, BYVAL STRPTR(sUseString))
       IF nIndex > -1 THEN '// We found it
          nValue = SendMessage(nStaticHandle, 409, nIndex, 0)
       END IF
    END IF
    FUNCTION = nValue
END FUNCTION

SUB ZWP_Destroy()
    ZWP_Message("DESTROY")
END SUB

FUNCTION ZWP_RUN () AS DWORD
    LOCAL nRet AS DWORD, zClass AS ASCIIZ * 16
    zClass = "ZWALLPAPER"
    nRet = FindWindow(zClass, "")
    IF nRet = 0 THEN
       'nRet = SHELL(EXE.Path$ + "ZWP.exe " + EXE.Path$ + "BBplugin\HUD_Ring.dll," + STR$(gh_Main), 1)
       nRet = MyShell(EXE.Path$ + "ZWP.exe " + EXE.Path$ + "BBplugin\HUD_Ring.dll," + STR$(gh_Main), %SW_SHOW, 200)
    END IF
    FUNCTION = nRet
END FUNCTION

FUNCTION ZWP_Handle() AS LONG
    LOCAL nRet AS LONG, zClass AS ASCIIZ * 16
    nRet = GetStaticValue("WPHANDLE")
    IF nRet = 0 THEN
       zClass = "ZWALLPAPER"
       nRet = FindWindow(zClass, "")'zClass)
       IF nRet THEN
          SetStaticValue("WPHANDLE", nRet)
          ZWP_SizeMove()
          ZWP_Message("PARENT," + STR$(gh_Main) + "," + STR$(0))
       END IF
    END IF
    FUNCTION = nRet
END FUNCTION

FUNCTION ZWP_Message(BYVAL sMsg AS STRING) AS LONG
    LOCAL szText AS ASCIIZ * 512
    szText = sMsg
    FUNCTION = SendMessage(ZWP_Handle(), %WM_SETTEXT, 0, BYVAL VARPTR(szText))
END FUNCTION

SUB ZWP_Play(BYVAL sAudio AS STRING)
    ZWP_Message("PLAY," + sAudio)
END SUB

SUB ZWP_SizeMove()
    LOCAL lpw AS RECT
    LOCAL x, y, w, h, hWnd, hPopup, hWndNext AS LONG

    'CALL GetWindowRect(gh_Main, lpw)
    'Tron3D uses the RECT of the GDImage child control instead of the main window. 
    CALL GetWindowRect(GetDlgItem(gh_Main, %IDC_GDImageCTRL), lpw)

    x = lpw.nLeft       '+ skGetSystemMetrics(%SK_DWM_LEFT)
    y = lpw.nTop        '+ skGetSystemMetrics(%SK_DWM_TOP)
    w = lpw.nRight - x  '- skGetSystemMetrics(%SK_DWM_RIGHT)
    h = lpw.nBottom - y '- skGetSystemMetrics(%SK_DWM_BOTTOM)

'   // Use this to move the window in case of AERO shake
'   // because setting the new location with SetWindowPos
'   // may fail!
    hWnd = ZWP_Handle() 
    hPopup = skGetDWMregion(gh_Main): IF hPopup = 0 THEN hPopup = gh_Main
    hWndNext = GetWindow(hPopup, 2)
    CALL SetWindowPos(hWnd, hWndNext, 0, 0, 0, 0, %SWP_NOMOVE OR %SWP_NOSIZE OR %SWP_NOOWNERZORDER OR %SWP_NOACTIVATE)
    CALL MoveWindow(hWnd, x, y, w, h, 0)

END SUB

SUB ZWP_Stop()
    ZWP_Message("STOP")
END SUB

SUB ZWP_Show(BYVAL sAudio AS STRING)
    LOCAL lpw AS RECT
    LOCAL x, y, w, h, hWnd, hPopup AS LONG
    CALL GetWindowRect(gh_Main, lpw)
    x = lpw.nLeft + skGetSystemMetrics(%SK_DWM_LEFT)
    y = -2000
    w = lpw.nRight - skGetSystemMetrics(%SK_DWM_RIGHT) - x
    h = lpw.nBottom - skGetSystemMetrics(%SK_DWM_BOTTOM) - y

'   // Use this to move the window in case of AERO shake
'   // because setting the new location with SetWindowPos
'   // may fail!
    hWnd = ZWP_Handle() 
    hPopup = skGetDWMregion(gh_Main): IF hPopup = 0 THEN hPopup = gh_Main
    CALL SetWindowPos(hWnd, GetWindow(hPopup, 2), 0, 0, 0, 0, %SWP_NOMOVE OR %SWP_NOSIZE OR %SWP_NOOWNERZORDER OR %SWP_NOACTIVATE)
    CALL MoveWindow(hWnd, x, y, w, h, 0)
'    CALL ShowWindow(hWnd, %SW_SHOW)
    ZWP_SizeMove()
    ZWP_Play(sAudio)
    CALL ShowWindow(hWnd, %SW_SHOW)
END SUB

SUB ZWP_Hide()
    CALL ShowWindow(ZWP_Handle(), %SW_HIDE)
    ZWP_Stop()
END SUB

SUB ZWP_UsePlugin(BYVAL sPlugin AS STRING)
    ZWP_Message("PLUGIN," + sPlugin)
END SUB

FUNCTION MyShell(zCmd AS ASCIIZ, BYVAL ShowWind AS LONG, BYVAL TimeLimit AS LONG) AS DWORD

    LOCAL sif AS STARTUPINFO
    LOCAL pif AS PROCESS_INFORMATION
    LOCAL nRet AS LONG
    LOCAL zClass AS ASCIIZ * 16
    LOCAL hWndEx AS DWORD 

    sif.cb = SIZEOF(sif)
    sif.dwFlags = %STARTF_USESHOWWINDOW
    sif.wShowWindow = ShowWind

    nRet = CreateProcess("", zCmd, _
	  	                   BYVAL 0, BYVAL 0, %FALSE, %NORMAL_PRIORITY_CLASS, _
                         BYVAL 0, BYVAL 0, sif, pif)
    IF nRet THEN
       CALL WaitForInputIdle(pif.hProcess, %INFINITE)

       IF TimeLimit THEN
          zClass = "ZWALLPAPER"
          hWndEx = FindWindow(zClass, "")
          WHILE hWndEx = 0
              CALL WaitForSingleObject(pif.hProcess, TimeLimit)
              hWndEx = FindWindow(zClass, "")
          WEND
          CALL CloseHandle(pif.hProcess)
          CALL CloseHandle(pif.hThread)
       END IF
    END IF
    FUNCTION = hWndEx

END FUNCTION

